
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>oracle ip字符与ip数值之间的相互转换 / 憋错料</title>

    <meta name="description" content="oracle ip字符与ip数值之间的相互转换 字符ip向数值转换: 1 create or replace function f_ip2number (v_ip in varchar2) return number is 2 i number; 3 begin 4 i:=regexp_substr(v_ip,'(\d{1,3})',1,1)*16777216 5 +regexp_substr(v_ip,'(\d{1,3})',1,2)*65536 6 +regexp_substr(v_ip,'(\d{1,3})',1,3)*256 7 +r">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">oracle ip字符与ip数值之间的相互转换</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>字符ip向数值转换：</p>
<pre>1 create or replace function f_ip2number (v_ip in varchar2) return number is
2 i number;
3 begin
4   i:=regexp_substr(v_ip,‘(\d{1,3})‘,1,1)*16777216
5      +regexp_substr(v_ip,‘(\d{1,3})‘,1,2)*65536
6      +regexp_substr(v_ip,‘(\d{1,3})‘,1,3)*256
7      +regexp_substr(v_ip,‘(\d{1,3})‘,1,4);
8    return i;
9 end;</pre>
<p>效果如下：</p>
<p>select f_ip2number(‘122.231.24.7‘) from dual;</p>
<p>2061965319</p>
<p>数值ip向字符转换：</p>
<pre> 1 create or replace function f_number2ip(num number)
 2 return varchar2 is
 3   ip_num_hex varchar2(8);
 4 begin
 5   ip_num_hex := lpad(trim(to_char(num, ‘XXXXXXXX‘)), 8, ‘0‘);
 6   return to_number(substr(ip_num_hex, 1, 2), ‘XX‘) || ‘.‘ ||
 7              to_number(substr(ip_num_hex, 3, 2), ‘XX‘) || ‘.‘ ||
 8              to_number(substr(ip_num_hex, 5, 2), ‘XX‘) || ‘.‘ ||
 9              to_number(substr(ip_num_hex, 7, 2), ‘XX‘);
10 exception
11 when others then
12   dbms_output.put_line(sqlerrm);
13   return null;
14 end;  </pre>
<p>效果如下：</p>
<p>select f_number2ip(2061965319) from dual;</p>
<p>122.231.24.7</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 09:26:50 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>oracle ip字符与ip数值之间的相互转换的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0aGPdJ4.html" rel="bookmark">细说oracle 11g rac 的ip地址</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				oracle11g开始,设置了SCAN ip,除此之外还有public ip,virtual ip,private ip,容易让人犯晕. 下面逐一解释: public ip: 类似与单实例的oracle数据库ip,主要用于管理\访问. virtual ip(vip): oracle在rac架构中专用,这个vip用于实现故障转移,当一个节点发生故障时,其vip会&quot;浮动&quot;到另外一个正常的节点,也即该正常节点对应着两个vip了. SCAN: SingleClient Access Name,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmN6dn0.html" rel="bookmark">&lbrack;oralce拾遗&rsqb;oracle修改监听IP地址</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在局域网中远程连接oracle时,一直提示拒绝连接,在确定防火墙关闭,oracle服务器监听端口开启的情况下,可能的错误就是oracle的监听IP地址不是预设的那样,而是本地的127.0.0.1. 排错过程不再细说,这里只分享由于主机名不正确而导致oracle拒绝连接的解决办法. =============================== 修改hosts文件 打开cmd,输入hostname,记下主机名 用记事本打开c:\windows\system32\drivers\etc\hosts			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4N1g1V3.html" rel="bookmark">oracle 11g 修改private ip， public ip， vip， scan ip</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				查看当前系统信息 [[email protected] ~]# crs_stat -t Name           Type           Target    State    Host ------------------------------------------------------------ ora.DATA.dg    ora....up.type ONLINE    ONLINE   node1 ora.FLASH.dg   ora....up.type ONLINE			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3OkyO93.html" rel="bookmark">&lbrack;转&rsqb;Oracle 11g RAC SCAN ip的原理及配置</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文地址:http://tiany.blog.51cto.com/513694/1421917/ Oracle 11g RAC SCAN ip的原理及配置   Oracle 11g RAC网格即插即用(GPnP)工作原理: SCAN概念:   先介绍一下什么叫SCAN,SCAN(Single Client Access Name)是Oracle从11g R2开始推出的,客户端可以通过SCAN特性负载均衡地连接到RAC数据库.SCAN提供一个域名来访问RAC,域名可以解析1个到3个(注意,最多3个			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0KWAe90.html" rel="bookmark">Oracle 限制连接的IP</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在oracle中,可以控制哪些IP可以连接数据库,哪些IP不能连接数据库.在9i及以后中,单纯的设定允许的IP和禁止的IP,修改sqlnet.ora是最好最快的方法 1.修改sqlnet.ora文件 在linux版本的oracle中,默认是没有sqlnet.ora这个文件的 $ cd $ORACLE_HOME/network/admin $ vi sqlnet.ora #增加如下部分 tcp.validnode_checking=yes #允许访问的IP tcp.invited_nodes=(1			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0kvQobM.html" rel="bookmark">Windows环境下修改Oracle实例监听IP地址</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Windows环境下修改Oracle实例监听IP地址. 配置文件路径:&lt;ORACLE_HOME&gt;\NETWORK\ADMIN 如:C:\Oracle11gR2\product\11.2.0\dbhome_1\NETWORK\ADMIN 一.修改配置文件:listener.ora # listener.ora Network Configuration File: D:\Oracle11gR2\product\11.2.0\dbhome_1\network\admin\listener.ora			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4AjaovM.html" rel="bookmark">TCP&sol;IP Http 和Https socket之间的区别</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				TCP/IP Http 和Https  socket之间的区别 TCP/IP是个协议组,它分为网络层,传输层和应用层, 在网络层有IP协议.ICMP协议.ARP协议.RARP协议和BOOTP协议. 在传输层中有TCP协议与UDP协议. 在应用层有FTP.HTTP.TELNET.SMTP.DNS等协议. TCP 是传输层协议,主要解决数据如何在网络中传输的,TCP连接是长连接第一次握手:客户端发送请求包到服务器,等待服务器确认第二次握手:服务器响应客户端请求,同时也发送一个回应包给客户端第三次握手			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzrO58M.html" rel="bookmark">柯南君：看TCP&sol;IP 之 二 &lpar;IP&colon;网际协议&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				柯南君上一章讲了&lt;TIP/IP之协议分层&gt;,本章主要讲一下IP协议,这个是大家最关注的   一.概念:       IP是TCP / IP协议族中最为核心的协议.所有的TCP.UDP.ICM P及IGMP数据都以IP数据报格式传输.许多刚开始接触TCP/IP的人对IP提供不可靠.无连接的数据报传送服务感到很奇怪,特别是那些具有X.25或SNA背景知识的人.      不可靠(unreliable)的意思是它不能保证IP数据报能成功地到达目的地.IP仅提供最好的传输服务.如果发生某种错误时,如某			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0Kab6y4.html" rel="bookmark">2&period;tcp&sol;ip协议分析-IP协议、ARP协议和RARP协议</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				IP协议是TCP/IP协议族中最核心的协议,它提供不可靠.无连接的数据报传输服务.所以理解IP协议对于我们学习网络至关重要. IP首部 重要字段介绍: 4bit首部长度:以4字节为单位,决定了IP首部长度最大为15*4=60,一般的IP数据报首部长度为20,此时该字段为5. 8bit的服务类型:包括一个3bit的优先权子字段(可以忽略),4bit的tos子字段和1bit的未用位但必须置0.4bit的TOS分别代表:最小延时.最大吞吐量.最高可靠性和最小费用. 比如在telnet交互应用中就要求有			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/949pnp3.html" rel="bookmark" class="title">去除input&lbrack;type&equals;number&rsqb;最右边的spinners&lpar;默认加减符号&rpar;</a>
					<div>
						// 去掉input[type=number]默认的加减号 input[type='number'] { -moz-appearance:textfield; } input[type=number] ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/XMgbER4.html" rel="bookmark" class="title">第六次作业。陈彬彬</a>
					<div>
						shadowL 软件测试第六次作业------bookstore项目缺陷测试 一.                 Bookstore项目测试缺陷报告 ———————————————————————— ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0byW8LM.html" rel="bookmark" class="title">Winpcap网络编程十之Winpcap实战&comma;两台主机通过中间主机通信</a>
					<div>
						注:本篇博客同样不针对于伸手党,源代码等等的我不会完全公开的,此篇文章写出来为大家的网络编程或者课程设计提供一定的思路.. 好,本次我们需要完成的任务是: 完成两台主机通过中间主机的数据通信(网络层) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38NRyZM.html" rel="bookmark" class="title">小数点输出精度控制问题&quest;&period;xml</a>
					<div>
						pre{ line-height:1; color:#9f1d66; background-color:#d2d2d2; font-size:16px;}.sysFunc{color:#5d57ff; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QNG6kM.html" rel="bookmark" class="title">站立会议（2016&sol;4&sol;22）</a>
					<div>
						今天我们三人行团队召开了第一次站立会议,由于前段时间我们有的活动参加,我们的首次会议推迟了几天.在今天,我们讨论了一下今后如何开始做自己的软件问题,由于我们还不具备专业知识,现在想到的还不够入门级别. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDZYLp3.html" rel="bookmark" class="title">java基础之集合框架总结篇</a>
					<div>
						(一).java集合框架轮廓(图片来自网络):下面两张图能说整个集合框架的层次和结构! (ps)这里的很多总结是我把某培训机构视频全部看了,发现老师总结的很好就把它贴在这里了,权当自己在写代码时不记得 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47NvDb3.html" rel="bookmark" class="title">Django  auth 登陆后页面跳转至&sol;account&sol;profile，修改跳转至其他页面</a>
					<div>
						这几天在学习django,django功能很强大,自带的auth,基本可以满足用户注册登陆登出,简单的用户注册登陆系统使用django auth足矣.当然也不是拿来就能用的,需要自己写登陆页面的模板, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3O7pAo3.html" rel="bookmark" class="title">使用oschina的git服务器图文流程</a>
					<div>
						参考了豆沙包的教程我自己也做了一遍也来写写我的心得和体会 由于报名参加了游戏蛮牛&lt;刀塔传奇&gt;开源项目,服务器+客户端,所以觉着不管时间怎么着,还是或多或少做点贡献吧.毕竟这种体验应该还是第 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0enxvv3.html" rel="bookmark" class="title">android 自定义控件步骤</a>
					<div>
						1.写一个类继承View或你想扩展功能的控件(比如TextView). public class CustomView extends View { }; 2.在/res/value下创建一个attr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49oBND0.html" rel="bookmark" class="title">ArcGIS Server 10&period;2 实战（五）spatial etl tool 格式转换服务</a>
					<div>
						上不同的地图服务平台对地图文件格式的要求多种多样,arcgis使用的文件很难应用于其他平台上,因此需要有格式转换的服务来克服这种使用不同平台带来的麻烦,下面以TIFF格式转GEOTIFF格式为例. 首 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoGA8QM.html" rel="bookmark" class="title">轰6K机长称遇外机干扰就兴奋：靠近点 给你拍照！ty</a>
					<div>
						土耳其媒体公布了嫌疑人的照片,并称是从警方获得的. &quot;学完之后就飞出去谈,谈完回来再思考,我就当作是教学相长.&quot;渐渐地,曾宪章发现,老师有时甚至还会请他来讲授实际经验,而他也不再只 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41BVEPM.html" rel="bookmark" class="title">vue数组进行分组</a>
					<div>
						数组进行分组使用switch方法 &lt;template&gt; &lt;v-layout&gt; &lt;v-card contextual-style=&quot;dark&quot; v-if ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NGVqBM.html" rel="bookmark" class="title">iOS APP性能优化</a>
					<div>
						1:应用启动时间 应用启动时,只加载启动相关的资源和必须在启动时加载的资源. 2:本地图片加载方式 本地图片加载常用方法有两种: (1),[UIImage imageNamed:@&quot;&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dzWJe4.html" rel="bookmark" class="title">SSM整合初级 简单的增删改查</a>
					<div>
						1.jar包 2.mybatis-config.xm配置文件 &lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot; ?&gt; &lt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmNGQQ0.html" rel="bookmark" class="title">python基础-解压序列</a>
					<div>
						解压序列 示例1:左边值必须和右边的值是一一对应的关系,否则会报错 1 &gt;&gt;&gt; a,b,c={1,2,3} #a=1,b=2,c=3 2 &gt;&gt;&gt; a 3 1 4 & ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qGQBaM.html" rel="bookmark" class="title">RxJava入门</a>
					<div>
						项目小版本上线,抽空简单学习了下久仰大名的RxJava 一.引入 个人觉得rxjava的特点: 强大灵活的事件流处理(多线程/多事件/复合对象) 强大灵活优雅简洁的异步 链式调用 可自动Lambda化 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e9d2w0.html" rel="bookmark" class="title">小白日记39：kali渗透测试之Web渗透-SQL手工注入（一）</a>
					<div>
						SQL手工注入(一) SQL注入:通过把SQL命令插入到Web表单递交或输入域名或页面请求的查询字符串,最终达到欺骗服务器执行恶意的SQL命令.[SQL注入原理] ##服务端程序将用户输入参数作为查询 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RjVBy0.html" rel="bookmark" class="title">JS对异步循环使用递归</a>
					<div>
						场景:有一个函数接收一个URL的数组,要求依次下载每个文件直到所有文件被成功下载. 如果API是同步的,很容易使用一个循环来实现 var downloadAllSync = function(urls ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4A2Od5M.html" rel="bookmark" class="title">玩转Win32开发（2）：完整的开发流程</a>
					<div>
						上一篇中我给各位说了一般人认为C++中较为难的东西——指针.其实对于C++,难点当然不局限在指针这玩意儿上,还有一些有趣的概念,如模板类.虚基类.纯虚函数等,这些都是概念性的东西,几乎每一本C++书上 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wDXvj4.html" rel="bookmark" class="title">JS学习笔记3&lowbar;函数表达式</a>
					<div>
						1.函数表达式与函数声明的区别 函数声明有“提升”(hoisting)的特性,而函数表达式没有.也就是说,函数声明会在加载代码时被预先加载到context中,而函数表达式只有在执行表达式语句时才会被加 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
